//import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; import netscape.javascript.*; import javax.comm.*; import javax.sound.midi.*; import javax.sound.midi.spi.*; import javax.sound.sampled.*; import javax.sound.sampled.spi.*; import javax.xml.parsers.*; import javax.xml.transform.*; import javax.xml.transform.dom.*; import javax.xml.transform.sax.*; import javax.xml.transform.stream.*; import org.xml.sax.*; import org.xml.sax.ext.*; import org.xml.sax.helpers.*; public class jambientNematodes extends BApplet {// jambientNematodes

  oscSend osObj;
  MessageOUT msg;

  int state; //0 waiting for file
  
  void setup()
  {
    oscInit();

    size(200,200);
    framerate(4);
    state = 0;
    BImage b; 
    b = loadImage("image.jpg"); 
    image(b, 0, 0); 
  }

  void loop()
  {
    
  }

  void KeyReleased(){
  }

  void SendGraphic(){
    color c;
    int x;
    int y;
    for(x=0; x<200; x=x+1) { 
      for(y=0; y<200; y=y+1) { 
        c = get (x,y);
        
      }
    } 
  }

  void oscInit(){
    String words[];
    String ip="";
    int sendport=0;
    int receiveport=0;
    String typ="";

    /*
    initialize a new osc server/client consisting of an
    osc receiver and and osc sender.
    receiveAtPort is the port number osc message should b send
    to at which this application will receive messages.
    the sendToPort nummer indicates the port number of the
    receiving port number of the other client/server.
    */

    String lines[] = loadStrings("oscprefs.txt");
    for (int i=0; i < lines.length; i++) {
      words = splitStrings(lines[i]);
      //println(words[0] + "[" + words[0].length());
      typ=words[0];
      if (words[0].compareTo("ipaddress:")==0){
        ip=words[1];
      } else if (words[0].compareTo("sendport:")==0){
        int slist[] = splitInts(words[1]);
        sendport=slist[0];
      } else if (words[0]=="receiveport:"){
        int slist[] = splitInts(words[1]);
        receiveport=slist[0];
      }
    }

    osObj   = new oscSend(ip,sendport);

  }

  ///////////////////////////
  //functions for sending OSC specific to jambientInchWorm
  //////////////////////////
/*
  void sendWormState(int worm, float x, float y, float p){
    msg = osObj.newMsg("/worm");  // create and prepare the new osc message
    msg.add(worm);
    msg.add(x/xbound);
    msg.add((height-y)/height);
    msg.add(p);
    osObj.sendMsg(msg);           // send the osc message
  }

  void sendWormOpen(int worm, boolean opened){
    if (worm!=-1) {
      msg = osObj.newMsg("/wrop");  // create and prepare the new osc message
      msg.add(worm);
      if (opened) {
        msg.add(1);
        //println ("opened " + worm);
      } else {
        msg.add(0);
        //println ("closed " + worm);
      }
      osObj.sendMsg(msg);           // send the osc message
    }
  }
*/
  //////////////////////
  //OSC stuff that follows is from Andreas Schlegel
  //////////////////////

  /*
  oscP5 by andreas schlegel
  if you have questions, feel free to contact andi at sojamo dot de
  this was downloaded from http://www.sojamo.de/iv/index.php?n=11

  version 0.1.1

  */

  /*
  create the necessary objects and instances
  for the osc communication
  */

  /*
  sending a message: go through function simpleMessage() and advancedMessage()
  receiving and analysing an incoming message: go through function analyseMessage()
  */

  //////////////////////////////////////////////////////////
  // SENDING MESSAGES
  //////////////////////////////////////////////////////////
  // notes
  // sc3 doesnt accept arrays and booleans
  // max didnt accept arrays (tested with OSC-for-Max-v2.4 on mac os 9)
  //////////////////////////////////////////////////////////
  void simpleMessage() {          // message /test with 2 arguments. a float and an int.
    // structure of this message: fisT
    // supercolloder 3 uses 1 and 0 instead of TRUE and FALSE
    // REAKTOR doesnt take strings
    msg = osObj.newMsg("/test");  // create and prepare the new osc message
    msg.add(12.44);             // add a float to the osc message
    msg.add(401);                // add an int to the osc message
    //msg.add("some string");     // add a string to the osc message
    //msg.add(true);              // add a boolean to the osc message
    osObj.sendMsg(msg);           // send the osc message
  }

  //////////////////////////////////////////////////////////
  // classes for osc communication.
  //  must be in here, as i dont have access to the BApplet itself.
  // successfully tested (browser and processing)
  // win xp java 1.4.2
  // win 98 java 1.3.1
  // max os x 10.3 java 1.4.2
  // mac os x 10.2.8 java 1.4.1
  // the code in oscP5.jar was adapted from the flosc source
  // code written by ben chun | http://www.benchun.net/flosc/
  //////////////////////////////////////////////////////////

  class oscSend extends BApplet {
    String      host;
    int         port;
    OscSender   os;

    oscSend(String host, int port) {
      this.host = host;
      this.port = port;
      this.os = new OscSender(this,host,port);
    }

    MessageOUT newMsg(String s) {
      return new MessageOUT(s);
    }

    void sendMsg(MessageOUT msg) {
      os.sendMsg(msg);
      //msg.printMessage(); // comment out this line if you dont want to post the sent message in the message window
    }

    void sendMsg(MessageOUT msg,String addr, int port) {
      os.sendMsg(msg,addr,port);
    }
  }

